namespace AircraftCarrier
{
    public partial class FormWarship : Form
    {
        private DrawingWarship _warship;
        /// <summary>
        ///  
        /// </summary>
        public DrawingWarship SelectedWarship { get; private set; } 
        public FormWarship()
        {
            InitializeComponent();
        }
        /// <summary>
        ///    
        /// </summary>
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxWarship.Width, pictureBoxWarship.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _warship?.DrawTransport(gr);
            pictureBoxWarship.Image = bmp;
        }
        /// <summary>
        ///   
        /// </summary>
        private void SetData()
        {
            Random rnd = new();
            _warship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxWarship.Width, pictureBoxWarship.Height);
            toolStripStatusLabelSpeed.Text = $": {_warship.Warship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_warship.Warship.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_warship.Warship.BodyColor.Name}";
        }
        /// <summary>
        ///    "Create"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            _warship = new DrawingWarship(rnd.Next(100, 300), rnd.Next(1000, 2000), color);
            SetData();
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _warship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _warship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _warship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _warship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        /// <summary>
        ///   
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PictureBoxWarship_Resize(object sender, EventArgs e)
        {
            _warship?.ChangeBorders(pictureBoxWarship.Width,pictureBoxWarship.Height);
            Draw();
        }
        /// <summary>
        ///    "Modification"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _warship = new DrawingAircraftCarrier(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor,
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();

        }

        private void ButtonSelectWarship_Click(object sender, EventArgs e)
        {
            SelectedWarship = _warship;
            DialogResult = DialogResult.OK;
        }
    }
}