﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class LineMap : AbstractMap
    {
        /// <summary>
        /// Цвет участка закрытого
        /// </summary>
        private readonly Brush barrierColor = new SolidBrush(Color.Brown);
        /// <summary>
        /// Цвет участка открытого
        /// </summary>
        private readonly Brush waterColor = new SolidBrush(Color.Blue);
        protected override void DrawBarrierPart(Graphics g, int i, int j)
        {
            g.FillRectangle(barrierColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }
        protected override void DrawRoadPart(Graphics g, int i, int j)
        {
            g.FillRectangle(waterColor, i * _size_x, j * _size_y, _size_x, _size_y);
        }
        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y = (float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i = 0; i < _map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeRoad;
                }
            }
            bool flag = true;
            while (counter < 20)
            {
                int lineX = _random.Next(11, 89);
                int lineY = _random.Next(11, 89);

                if (flag)
                {
                    for (int i = lineY; i <= lineY + 10; i++)
                        _map[lineX, i] = _barrier;
                    flag = false;
                }
                else
                {
                    for (int i = lineX; i <= lineX + 10; i++)
                        _map[i, lineY] = _barrier;
                    flag = true;
                }
                counter++;
            }
        }
    }
}
