﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class WarshipCompareByColor : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xWarship = x as DrawingObjectWarship;
            var yWarship = y as DrawingObjectWarship;
            if (xWarship == yWarship)
            {
                return 0;
            }
            if (xWarship == null)
            {
                return 1;
            }
            if (yWarship == null)
            {
                return -1;
            }
            var xEntity = xWarship.GetWarship.Warship;
            var yEntity = yWarship.GetWarship.Warship;
            var colorWeight = xEntity.BodyColor.ToArgb().CompareTo(yEntity.BodyColor.ToArgb());
            if (colorWeight != 0 || xEntity is not EntityAircraftCarrier xEntityAircraftCarrier ||
                yEntity is not EntityAircraftCarrier yEntityWarmlyShip)
            {
                return colorWeight;
            }
            return xEntityAircraftCarrier.DopColor.ToArgb().CompareTo(yEntityWarmlyShip.DopColor.ToArgb());
        }
    }
}
