﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AircraftCarrier
{
    internal class WarshipCompareByType : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xWarship = x as DrawingObjectWarship;
            var yWarship = y as DrawingObjectWarship;
            if (xWarship == yWarship)
            {
                return 0;
            }
            if (xWarship == null)
            {
                return 1;
            }
            if (yWarship == null)
            {
                return -1;
            }
            if (xWarship.GetWarship.GetType().Name != yWarship.GetWarship.GetType().Name)
            {
                if (xWarship.GetWarship.GetType() == typeof(DrawingWarship))
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xWarship.GetWarship.Warship.Speed.CompareTo(yWarship.GetWarship.Warship.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xWarship.GetWarship.Warship.Weight.CompareTo(yWarship.GetWarship.Warship.Weight);
        }
    }
}
